%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%Simulation 4 in the Manuscrpit%%%%%%%
%%% Creating an ANN with HMC method for N=5000 data
tic;
load Sim4DataGenerationN5000.mat


nin = 2;		% Number of inputs.
nhidden = 5;		% Number of hidden units.
nout = 1;		% Number of outputs.
alpha = 0.075;		% weight decay in Maximum Liklihood setting 
 
nethmc = mlp(nin, nhidden, nout, 'poisson',alpha);
nethmc = mlpinit(nethmc, 10);

nsamples = 1000;		% Number of retained samples.

options = foptions;     % Default options vector.
options(1) = 1;		% Switch on diagnostics.
options(5) = 1;		% Use persistence
options(7) = 20;	% Number of steps in trajectory.
options(14) = nsamples;	% Number of Monte Carlo samples returned. 
options(15) = 100;	% Number of samples omitted at start of chain.
options(17) = 0.95;	% Alpha value in persistence
options(18) = 0.0002;	% Step size.

w = mlppak(nethmc);
% Initialise HMC
hmc('state', 42);
[samples, energies] = hmc('neterr', w, options, 'netgrad', nethmc, trainx(:,[1 2]), traint);


 yhmc=zeros(size(testX,1),nsamples);
for k = 1:nsamples
  w2 = samples(k,:);
  net2 = mlpunpak(nethmc, w2);
  yhmc(:,k) = mlpfwd(net2, testX(:,[1 2]));
end
pred = mean(yhmc,2);
stdpred=std(yhmc,0,2);
lowerstd=pred-stdpred;
upperstd=pred+stdpred;

trainlambda=transpose(lambda(1:2000));
testlambda=transpose(lambda(1601:2000));
TestDataAll=[testX(:,[1 2]),testlambda,testy,pred,stdpred,lowerstd,upperstd];

opt_time=toc; % Storing the execution time

%ANN with HMC approach Prediction Errors
RMSEHMC=sqrt((sum((pred-testlambda).^2))/size(testlambda,1));
MAEHMC=sum(abs(pred-testlambda))/size(testlambda,1);
MPEHMC=sum(abs((pred-testlambda)./testlambda))/size(testlambda,1);
RSEHMC=(sum((pred-testlambda).^2))/(sum((testlambda-mean(testlambda)).^2));

save Sim4HMCmethod.mat