%%%%%Simulation 4 in the Manuscrpit%%%%%%% 
%Using 5 fold cross Validation with N=5000 data%

tic;
load Sim4DataGenerationN5000.mat

rand('state', 466);
randn('state',466);
%create a training error martix
train_error=zeros(25,5);
valid_error=zeros(25,5);


% Set up network parameters.

network = cell(25,1);
network_valid = cell(25,1);
nin=2;		
nout = 1;			% Number of outputs.
alpha = 0.075; % hyperparametr value 
 
%Create the ANN models and storing their train and validation errors for
%different hidden nodes and folds.
for i=3:13
        nhidden = i ; % Number of hidden units.
        for j=1:5
        net = mlp(nin, nhidden, nout, 'poisson', alpha);
   options = foptions;
            options(1)=1;
            options(2)=1e-5;
            options(3)=1e-5;
            options(14)=1000;
           
       [net]=netopt(net, options,trainkfold_x{j}(:,[1 2]),trainkfold_t{j},'scg');

train_error(i,j)=mlperr(net,trainkfold_x{j}(:,[1 2]),trainkfold_t{j});

       [nettrain]=netopt(net,options,validkfold_x{j}(:,[1 2]),validkfold_t{j},'scg');
       
 valid_error(i,j)=mlperr(nettrain,validkfold_x{j}(:,[1 2]),validkfold_t{j});
  network{i,j}=net;  
        network_valid{i,j}=nettrain;
        end
end
 opt_time=toc;% Storing the execution time
 
 %Find the optimal number of hidden nodes (Index) and the fold number(Index_best) with the optimal cross validation error,
 %This isstored in the cell array called: valid_error(i,j) where i is the Index number and j is the fold number.
 
Index = 10;
Index_best = 2; 
N=size(validkfold_x{Index_best},1);


%Making predictions with ANN with ML approach
[trainy,trainz,traina] = mlpfwd(network_valid{Index,Index_best},trainx(:,[1 2]));
[testy,testz,testa] = mlpfwd(network_valid{Index,Index_best},testX(:,[1 2]));


%Creating the linear Poisson regression model and making predictions
[b,dev,stats] = glmfit(trainx(:,[1 2]),traint,'poisson','link','log');
Xb=[ones(size(testX,1),1) testX(:,[1 2])];
predTesty=exp(Xb*stats.beta);

%Creating the negative binomial model and making predictions
negbintrainx=[ones(size(trainx,1),1) trainx(:,[1 2])];
negbintestx=[ones(size(testX,1),1) testX(:,[1 2])];
statsnegbin = nbreg(negbintrainx,traint);
predTestnegbinomy=exp(negbintestx*statsnegbin.b);

truelab=lambda(4001:5000)'; %Selection of actual lambdain the testing data set

%ANN with ML approach Prediction Errors
RMSETest=sqrt(sum((testy-truelab).^2)/size(testy,1));
MAETest=sum(abs(testy-truelab))/size(testy,1);
MPETest=sum(abs((testy-truelab)./testy))/size(testy,1);
RSETest=(sum((testy-truelab).^2))/(sum((testy-mean(testy)).^2));

%Poisson Prediction Errors
RMSETestPoisnReg=sqrt(sum((predTesty-truelab).^2)/size(predTesty,1));
MAETestPoisnReg=sum(abs(predTesty-truelab))/size(predTesty,1);
MPETestPoisnReg=sum(abs((predTesty-truelab)./truelab))/size(predTesty,1);
RSETestPoisnReg=(sum((predTesty-truelab).^2))/(sum((truelab-mean(truelab)).^2));

%Negative Binomial Prediction Errors
RMSETestNegBinom=sqrt(sum((predTestnegbinomy-truelab).^2)/size(predTestnegbinomy,1));
MAETestNegBinom=sum(abs(predTestnegbinomy-truelab))/size(predTestnegbinomy,1);
MPETestNegBinom=sum(abs((predTestnegbinomy-truelab)./truelab))/size(predTestnegbinomy,1);
RSETestNegBinom=(sum((predTestnegbinomy-truelab).^2))/(sum((truelab-mean(truelab)).^2));

scatter(lambda(4001:5000)',testy)

save Sim4ANNAlpha075N=5000MLapproach.mat