%path /Users/Manoj/Dropbox/Hansi/NonLinearPoissonReg/netlab3_3Edited
load HansiPoissonEvidence2.mat
x1 = unifrnd(0,2.5,1,5000);
x2 = unifrnd(1,2,1,5000);
x3 = unifrnd(-2,3,1,5000);
x4 = unifrnd(0,3,1,5000);

%lambda=exp(0.075*(x2.^(x3))+(0.12./(x4-4))+2);
lambda=exp(0.075*(x1.^2)/0.2+(3*x2));
hist(lambda);
xlabel('Poisson Mean')
ylabel('Frequncy Distribution')

t1=poissrnd(lambda,1,5000);
%ex1=normrnd(0,1,1,1000);
%ex2=unifrnd(0,1,1,1000);
%data=[x2' x3' x4' t1'];
data=[x1' x2' t1'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
trainx=data(1:4000,1:end-1);
traint=data(1:4000,end);
testX=data(4001:5000,1:end-1);
testt=data(4001:5000,end);

rand('state',342);

% Set up network parameters.
nin = 2;		% Number of inputs.
nhidden = 3;		% Number of hidden units.
nout = 1;		% Number of outputs.
alpha = 0.01;		% Initial prior hyperparameter in Bayesian setting.

 
%beta_init = 50.0;	% Initial noise hyperparameter.

% Create and initialize network weight vector.
net = mlp(nin, nhidden, nout, 'poisson', alpha);


% Set up vector of options for the optimiser.
nouter = 20;			% Number of outer loops.
ninner = 5;			% Number of innter loops.
options = zeros(1,18);		% Default options vector.
options(1) = 1;			% This provides display of error values.
options(2) = 1.0e-7;		% Absolute precision for weights.
options(3) = 1.0e-7;		% Precision for objective function.
options(14) = 1000;		% Number of training cycles in inner loop. 

% Train using scaled conjugate gradients, re-estimating alpha and beta.
for k = 1:nouter
  net = netopt(net, options, trainx, traint, 'scg');
  [net, gamma] = evidence(net, trainx, traint, ninner);
  fprintf(1, '\nRe-estimation cycle %d:\n', k);
  fprintf(1, '  alpha =  %8.5f\n', net.alpha);
  %fprintf(1, '  beta  =  %8.5f\n', net.beta);
  fprintf(1, '  gamma =  %8.5f\n\n', gamma);
end

% Evaluate error bars.
%[y, sig2] = netevfwd(mlppak(net), net, trainx, traint, datatestx');
%sig = sqrt(sig2);
[y, sig2] = netevfwd(mlppak(net), net, trainx, traint, testX);
trainlambda=transpose(lambda(1:4000));
testlambda=transpose(lambda(4001:5000));
%datatrainx=trainx(1:4000)';
%datatestx=testX(4001:5000)';


h = figure;
scatter(datatestx,testlambda, 'ok')
xlabel('Input')
ylabel('Target')
line(datatestx,testlambda)

figure(h); hold on;
scatter(datatestx, y, 'or')

plot((1:5).^2,'o-','linewidth',3,'markersize',40,'markerfacecolor','g')

figure(h)
hold on
axis([0 2.5 5 15])
%fplot('sin(2*pi*x)', [0 1], '-g')
legend('data');
% Plot the data, the original function, and the trained network function.
[y, z] = mlpfwd(net, sorteddatatestx);
%testy=y(1:15);
newdata=[datatestx',testlambda];
figure(h);% hold on;
h1=figure;
plot(sorteddatatestx, testlambda,'c*')
xlabel('Input')
ylabel('Target')
plot(sorteddatatestx, y, '-o');
legend('data', 'predict');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Maximum Likelihood Setting%%%%%%%%
% Set up network parameters.
nin = 1;		% Number of inputs.
nhidden = 3;		% Number of hidden units.
nout = 1;		% Number of outputs.
alpha = 0.01;		% weight decay in Maximum Liklihood setting 
netml = mlp(nin, nhidden, nout, 'poisson',alpha);

% Set up vector of options for the optimiser.

options = zeros(1,18);		% Default options vector.
options(1) = 1;			% This provides display of error values.
options(2) = 1.0e-7;		% Absolute precision for weights.
options(3) = 1.0e-7;		% Precision for objective function.
options(14) = 1000;		% Number of training cycles in inner loop. 

% MLP Train using scaled conjugate gradients.
[netml, options] = netopt(netml, options, trainx, traint, 'scg');

%yml=mlpfwd(netml,datatestx');
yml=mlpfwd(netml,testX);

RMSEBayes=sqrt((sum((testlambda-y).^2))/size(testlambda,1));
RMSEML=sqrt((sum((testlambda-yml).^2))/size(testlambda,1));

% Evaluate error bars.
[y, sig2] = netevfwd(mlppak(net), net, trainx, traint, datatestx');
sig = sqrt(sig2);
trainlambda=transpose(lambda(1:40));
testlambda=transpose(lambda(4001:4040));
datatrainx=trainx(1:40)';
datatestx=testX(1:40)';
sorteddatatestx=sort(datatestx');

h = figure;
scatter(datatestx,testlambda, 'ok')
xlabel('Input')
ylabel('Target')

TestDataAll=[testx',testlambda,y,yml];

[TT,I]=sort(TestDataAll(:,1));
Ex41=TestDataAll(I,:); 

h=figure;
scatter(Ex41(:,1),Ex41(:,2),'oy')
hold on;
plot(Ex41(:,1),Ex41(:,2),'--r')
hold on;
plot(Ex41(:,1),Ex41(:,3),'-g')
xlabel('Input')
ylabel('Data/Predictions')
axis([0 2.5 5 15])
legend('data', 'Bayes Predictions','Maximum Likelihood Predictions');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%HMC Sampling%%%%%%%%%%%%%%

nethmc = mlp(nin, nhidden, nout, 'poisson', alpha);
nethmc = mlpinit(nethmc, 10);

nsamples = 100;		% Number of retained samples.

options = foptions;     % Default options vector.
options(1) = 1;		% Switch on diagnostics.
options(5) = 1;		% Use persistence
options(7) = 10;	% Number of steps in trajectory.
options(14) = nsamples;	% Number of Monte Carlo samples returned. 
options(15) = 300;	% Number of samples omitted at start of chain.
options(17) = 0.95;	% Alpha value in persistence
options(18) = 0.002;	% Step size.

w = mlppak(nethmc);
% Initialise HMC
hmc('state', 42);
[samples, energies] = hmc('neterr', w, options, 'netgrad', nethmc, trainx, traint);

pred = zeros(size(testx'));
for k = 1:nsamples
  w2 = samples(k,:);
  net2 = mlpunpak(nethmc, w2);
  yhmc = mlpfwd(net2, testx');
  % Sum predictions
  pred = pred + yhmc;
  %h4 = plot(testx', yhmc, '-r', 'LineWidth', 1);
end
pred = pred./nsamples;
TestDataAll=[testx',testlambda,y,yml,pred];

RMSEHML=sqrt((sum((testlambda-pred).^2))/size(testlambda,1));

[TT,I]=sort(TestDataAll(:,1));
Ex41hmc=TestDataAll(I,:);

% Plot data
hnew=figure; 
plot(Ex41hmc(:,1), Ex41hmc(:,2), 'oy', 'LineWidth', 2, 'MarkerFaceColor', 'blue');
%axis([0 2.5 5 15])
hold on;
plot(Ex41hmc(:,1),Ex41hmc(:,3), '-r', 'LineWidth', 1);
hold on;
plot(Ex41hmc(:,1),Ex41hmc(:,4), '-b', 'LineWidth', 1);
hold on;
plot(Ex41hmc(:,1),Ex41hmc(:,5), '-g', 'LineWidth', 1);
xlabel('Input')
ylabel('Data/Prediction')
legend('Data', 'Evidence Prediction','ML Prediction', 'HMC Prediction');

save HansiPoissonEvidence2.mat





